import * as React from "react";
import { ContentRef, KernelNotStartedProps, LocalKernelProps, RemoteKernelProps } from "@nteract/core";
import { RecordOf } from "immutable";
import { WidgetModel } from "@jupyter-widgets/base";
import { CellId } from "@nteract/commutable";
interface JupyterWidgetData {
    model_id: string;
    version_major: number;
    version_minor: number;
}
interface Props {
    data: JupyterWidgetData;
    modelById: (model_id: string) => Promise<WidgetModel>;
    kernel?: RecordOf<KernelNotStartedProps> | RecordOf<LocalKernelProps> | RecordOf<RemoteKernelProps> | null;
    id: CellId;
    contentRef: ContentRef;
}
interface State {
    model?: WidgetModel;
}
/**
 * The WidgetDisplay takes a model_id, which is returned by the
 * display_data payload that is returned from the execution of a
 * cell containing an ipywidget. This model_id is used to retrieve
 * the initial model for the widget from the comms state in the
 * core state model.
 */
export declare class WidgetDisplay extends React.Component<Props, State> {
    static MIMETYPE: string;
    constructor(props: Props);
    componentDidMount(): Promise<void>;
    render(): JSX.Element | null;
}
declare const _default: import("react-redux").ConnectedComponent<typeof WidgetDisplay, Pick<Props, "id" | "data" | "modelById" | "kernel" | "contentRef"> & Props>;
export default _default;
